(* $Id: godi_update.mli 678 2007-02-25 17:16:54Z gerd $
 * ----------------------------------------------------------------------
 * Copyright 2003 by Gerd Stolpmann.
 *
 * This file is part of godi-tools.
 *
 * godi-tools is free software; you can redistribute it and/or modify it
 * under the conditions in the file LICENSE.
 *
 * godi-tools is distributed WITHOUT ANY WARRANTY, as detailed in the
 * file LICENSE.
 *)

open Godi_types
open Godi_exec

(* Note: All the following functions prefer User_error exceptions anyway. *)


val install_build_instructions_for : 
      ?interactivity:interactivity ->
      ?protocol:collector ->
      string ->    (* URL prefix *)
      string ->    (* name *)
      string ->    (* version *)
      int ->       (* pkgrev *)
	unit
  (* Download and install the build.tgz unconditionally *)

val update_build_instructions_for : 
      ?interactivity:interactivity ->
      ?protocol:collector ->
      string -> unit
  (* Download and install the build.tgz only if the available version is
   * newer than the installed instance. The passed string is the package
   * name (without version/pkgrev).
   *)

val update_build_instructions : 
      ?interactivity:interactivity ->
      ?protocol:collector ->
      unit -> unit
  (* Download and install all build.tgz for which an update is available *)

val update_available :
      ?interactivity:interactivity ->
      ?protocol:collector ->
      unit -> unit
  (* Update the list of available packages. 
   * Important note: This is now an in-memory list, as available.current
   * reflects only the state of one GODI server.
   *)

(*
val parse_available :
      ?protocol:collector ->
      unit ->
	(string * (string * string)) list
*)
  (* Parse available.current *)
  (* No longer exported! *)
